<template>
    <section class="loginForm">
      <form class="loginFields" @submit.prevent="loginUser">
        <div class="inputFields">
          <h1 class="logIn">Log In</h1>
  
          <div class="inputLabels">
            <label class="label" for="username">Username</label>
            <input
              class="inputBoxes"
              type="text"
              id="username"
              v-model="username"
              required
            />
            <span class="error-message" v-if="error.username">{{ error.username }}</span>
          </div>
  
          <div class="inputLabels">
            <label class="label" for="password">Password</label>
            <input
              class="inputBoxes"
              type="password"
              id="password"
              v-model="password"
              required
            />
            <span class="error-message" v-if="error.password">{{ error.password }}</span>
          </div>
        </div>
  
        <button class="loginButton" type="submit">
          <b class="logInText">Log In</b>
        </button>
  
        <div class="notHaveAnAccountContainer">
          <span class="notHaveAnAccount">Don’t have an account? </span>
          <b class="registerHere" @click="$emit('show-register')">Sign Up here</b>
        </div>
      </form>
    </section>
  </template>
  
  <script lang="ts">
  import { defineComponent, ref } from 'vue';
  
  export default defineComponent({
    name: 'LoginForm',
    emits: ['show-register'],
    setup() {
      const username = ref('');
      const password = ref('');
      const error = ref({
        username: '',
        password: '',
      });
  
      const loginUser = async () => {
        // Clear previous error messages
        error.value.username = '';
        error.value.password = '';
  
        try {
          console.log("Attempting to log in..."); // Debugging log
          const response = await fetch('http://localhost:8000/api/login', {
            method: 'POST',
            headers: {
              'Content-Type': 'application/json',
            },
            body: JSON.stringify({
              username: username.value,
              password: password.value,
            }),
          });
  
          // Check if response is ok
          if (!response.ok) {
            const data = await response.json();
            console.log("Login failed:", data); // Debugging log
            const errorMessage = data.detail;
            // Handle specific errors
            if (errorMessage.includes("Invalid credentials")) {
              error.value.username = "Invalid username or password.";
            }
          } else {
            // Handle successful login
            const data = await response.json();
            console.log("Login successful!", data); // Debugging log
            // Store token or redirect the user here
            // For example, you can store the token in local storage:
            // localStorage.setItem('access_token', data.access_token);
            // Or redirect to a dashboard page
          }
        } catch (err) {
          console.error("Error during login:", err); // Debugging log
          error.value.password = "An unexpected error occurred. Please try again.";
        }
      };
  
      return {
        username,
        password,
        loginUser,
        error,
      };
    },
  });
  </script>
  
  <style scoped>
  .loginForm {
    width: 100%;
    display: flex;
    justify-content: center;
    padding: 0 var(--padding-20xl) 0 var(--padding-19xl);
  }
  
  .loginFields {
    width: 100%;
    max-width: 400px; /* Consistent width with registration form */
    margin: 0;
    display: flex;
    flex-direction: column;
    align-items: center;
    justify-content: flex-start;
    gap: var(--gap-34xl);
    background-color: #1e1e2f; /* Matching background color */
    padding: 20px; /* Padding for spacing */
    border-radius: 8px; /* Rounded corners */
    box-shadow: 0 4px 20px rgba(0, 0, 0, 0.2); /* Subtle shadow for depth */
  }
  
  .inputFields {
    width: 100%;
    display: flex;
    flex-direction: column;
    align-items: flex-start;
    gap: var(--gap-4xl);
  }
  
  .logIn {
    margin: 0;
    width: 100%;
    font-size: var(--font-size-13xl);
    font-family: var(--font-audiowide);
    color: var(--color-white);
    text-align: center; /* Center the heading */
  }
  
  .inputLabels {
    width: 100%;
    display: flex;
    flex-direction: column;
    gap: var(--gap-7xs);
  }
  
  .label {
    font-size: var(--font-size-base);
    font-family: var(--font-open-sans);
    color: var(--color-white);
  }
  
  .inputBoxes {
    width: 100%;
    border: 2px solid var(--color-white);
    background-color: #29293d; /* Darker input background */
    height: 45px;
    border-radius: 8px; /* Matching rounded corners */
    padding: 0 10px;
    color: var(--color-white);
    font-family: var(--font-open-sans);
    transition: all 0.3s ease; /* Smooth transition for focus */
  }
  
  .inputBoxes:focus {
    border-color: #ae45c9; /* Focused border color */
    background-color: #3b3b4f; /* Change background on focus */
  }
  
  .loginButton {
    cursor: pointer;
    border: none;
    padding: 15px 25px; /* Increased padding for a larger button */
    background-color: #ae45c9; /* Vibrant purple background color */
    border-radius: 8px; /* Rounded corners */
    display: flex;
    align-items: center;
    justify-content: center;
    font-size: 1rem; /* Consistent font size */
    font-family: var(--font-open-sans);
    color: white; /* White text color */
    transition: background 0.3s ease, transform 0.2s; /* Smooth transition */
    margin-top: 15px; /* Added margin for spacing */
  }
  
  .loginButton:hover {
    background-color: #9c3cb6; /* Darker purple on hover */
    transform: scale(1.05); /* Slightly enlarge on hover */
  }
  
  .logInText {
    font-weight: bold;
  }
  
  .notHaveAnAccountContainer {
    width: 100%;
    font-size: var(--font-size-base);
    color: var(--color-white);
    text-align: center; /* Center the text */
    cursor: pointer;
  }
  
  .notHaveAnAccount,
  .registerHere {
    font-family: var(--font-open-sans);
  }
  
  .registerHere {
    text-decoration: underline;
    font-weight: bold;
  }
  
  .error-message {
    color: red;
    font-size: 0.875em; /* Error message styling */
  }
  </style>
  